<template>
  <template-page
    ref="pageRef"
    :getList="getList"
    :optionsEvensGroup="optionsEvensGroup"
    :exportList="exportList"
    :columnParsing="columnParsing"
    :tableAttributes="tableAttributes"
    :tableEvents="tableEvents"
  >
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'

import {
  abandonData,
  examineBatch,
  examineJudge,
  getList,
  saleOrderListV2,
  saleOrderListV2Export
} from '@/api/supply/sales'
// import SalesDetail from '@/views/supply/sales/components/sales_detail'
// import SalesExamine from '@/views/supply/sales/components/sales_examine'
// import SalesReturnForm from '@/views/supply/sales/components/sales_return_form'
// import ExamineDialog from '@/components/Common/examine-dialog'
import { getCategoryList } from '@/api/common'

let that
export default {
  components: {
    TemplatePage
  },
  filters: {
    statusFilter(val) {
      if (that.statusList.length) {
        const obj = that.statusList.find(o => o.value == val)
        return obj ? obj.label : ''
      }
      return ''
    },
    orderTypeFilter(val) {
      if (that.orderTypeList.length) {
        const obj = that.orderTypeList.find(o => o.value == val)
        return obj ? obj.label : ''
      }
      return ''
    },
    billStatusFilter(val) {
      const MAP = {
        1: '已开票',
        0: '未开票'
      }
      return MAP[val]
    }
  },
  data() {
    return {
      // 事件组合
      optionsEvensGroup: [],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      recordSelected: [],

      currentPage: 1, // 当前页码
      pageSize: 10, // 每页数量
      listTotal: 0, // 列表总数
      dataList: null, // 列表数据
      listLoading: false, // 列表加载loading
      screenForm: {
        // 筛选表单数据
        orderNum: '',
        jxsName: '',
        jxsNum: '',
        chName: '',
        chNum: '',
        model: '',
        warehouse: '',
        date: [],
        status: '',
        approval: [],
        printTime: [],
        mainOrderId: '',
        printDesc: null,
        syncStatus: '',
        categoryId: '',
        invoiceDate: [],
        id: ''
      },
      statusList: [
        { label: '已保存', value: 'SAVE' },
        { label: '待审核', value: 'WAIT' },
        { label: '审核通过', value: 'OK' }
        // { label: '审核驳回', value: 'FAIL' },,
      ],
      orderTypeList: [
        { label: '商用', value: 'TRADE' },
        { label: '家用', value: 'HOME' },
        { label: '零售单', value: 'RETAIL' },
        { label: '销售政策单', value: 'RETAIL_POLICY' },
        { label: '置换单家用', value: 'PERMU_HOME' },
        { label: '置换商用', value: 'PERMU_TRADE' },
        { label: '置换零售', value: 'PERMU_RETAIL' },
        { label: '置换销售政策单', value: 'PERMU_RETAIL_POLICY' },
        { label: '调拨单零售', value: 'REQUISITION_RETAIL' },
        { label: '调拨单销售政策', value: 'REQUISITION_RETAIL_POLICY' },
        { label: '调拨单商用', value: 'REQUISITION_TRADE' },
        { label: '调拨单家用', value: 'REQUISITION_HOME' }
      ],
      isCollapse: true,
      queryItem: {},
      isShowDetail: false,
      isShowExamine: false,
      isShowReturnForm: false,
      value1: '',
      choiceDate: '',
      multipleSelection: [],
      isShowExamineDialog: false,
      examineForm: {
        status: '',
        remark: ''
      },
      categoryList: [],
      setDisabled: {
        disabledDate: time => {
          if (this.choiceDate) {
            const res = 13 * 24 * 3600 * 1000
            const minTime = this.choiceDate - res
            const maxTime = this.choiceDate + res
            return time.getTime() < minTime || time.getTime() > maxTime
          }
        },
        onPick: ({ maxDate, minDate }) => {
          this.choiceDate = minDate.getTime()
          if (maxDate) this.choiceDate = ''
        }
      }
    }
  },

  computed: {
    exParams() {
      return {
        examineStatus: this.screenForm.status,
        orderNo: this.screenForm.orderNum,
        customerName: this.screenForm.jxsName,
        customerNumber: this.screenForm.jxsNum,
        materialName: this.screenForm.chName,
        materialNumber: this.screenForm.chNum,
        specification: this.screenForm.model,
        correspondName: this.screenForm.warehouse,
        startTime: this.screenForm.date ? this.screenForm.date[0] : '',
        endTime: this.screenForm.date ? this.screenForm.date[1] : '',
        syncStatus: this.screenForm.syncStatus,
        categoryId: this.screenForm.categoryId,
        invoiceStartTime: this.screenForm.invoiceDate ? this.screenForm.invoiceDate[0] : '',
        invoiceEndTime: this.screenForm.invoiceDate ? this.screenForm.invoiceDate[1] : '',
        approvalStartTime: this.screenForm.approval ? this.screenForm.approval[0] : '',
        approvalEndTime: this.screenForm.approval ? this.screenForm.approval[1] : '',
        printStartTime: this.screenForm.printTime ? this.screenForm.printTime[0] : '',
        printEndtTime: this.screenForm.printTime ? this.screenForm.printTime[1] : '',
        mainOrderId: this.screenForm.mainOrderId,
        printTimeDesc: this.screenForm.printDesc,
        id: this.screenForm.id
      }
    }
  },

  beforeCreate() {
    that = this
  },

  created() {
    // this.getList()
    // this.getCategoryList()
  },

  methods: {
    // 列表请求函数
    getList: saleOrderListV2,
    // 列表导出函数
    exportList: saleOrderListV2Export,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    operation() {
      return (h, { row, index, column }) => {
        return (
          <div class="operation-btns">
            <el-button size="mini" type="text" onClick={async () => {}}>
              查看
            </el-button>
          </div>
        )
      }
    },

    // 查询列表
    // getList() {
    //   this.listLoading = true

    //   const params = {
    //     pageNum: this.currentPage,
    //     pageSize: this.pageSize,
    //     examineStatus: this.screenForm.status,
    //     orderNo: this.screenForm.orderNum,
    //     customerName: this.screenForm.jxsName,
    //     customerNumber: this.screenForm.jxsNum,
    //     materialName: this.screenForm.chName,
    //     materialNumber: this.screenForm.chNum,
    //     specification: this.screenForm.model,
    //     correspondName: this.screenForm.warehouse,
    //     syncStatus: this.screenForm.syncStatus,
    //     categoryId: this.screenForm.categoryId,
    //     invoiceStartTime: this.screenForm.invoiceDate ? this.screenForm.invoiceDate[0] : '',
    //     invoiceEndTime: this.screenForm.invoiceDate ? this.screenForm.invoiceDate[1] : '',
    //     startTime: this.screenForm.date ? this.screenForm.date[0] : '',
    //     endTime: this.screenForm.date ? this.screenForm.date[1] : '',
    //     approvalStartTime: this.screenForm.approval ? this.screenForm.approval[0] : '',
    //     approvalEndTime: this.screenForm.approval ? this.screenForm.approval[1] : '',
    //     printStartTime: this.screenForm.printTime ? this.screenForm.printTime[0] : '',
    //     printEndtTime: this.screenForm.printTime ? this.screenForm.printTime[1] : '',
    //     printTimeDesc: this.screenForm.printDesc,
    //     mainOrderId: this.screenForm.mainOrderId,
    //     id: this.screenForm.id
    //   }
    //   getList(params).then(res => {
    //     res.data.records.forEach(item => {
    //       item.sums1 = ['refundableQty']
    //       item.sums2 = ['price', 'payAmount']
    //     })
    //     this.dataList = res.data.records
    //     this.listTotal = res.data.total
    //     this.listLoading = false
    //   })
    // },
    // updateReceipt() {
    //   if (!this.value1) {
    //     this.$errorMsg('请选择时间')
    //     return
    //   }
    //   updateReceipt({
    //     startTime: this.value1[0],
    //     endTime: this.value1[1]
    //   }).then(res => {
    //     this.getList()
    //     this.$successMsg('已更新')
    //     this.value1 = ''
    //   })
    // },
    // 提交筛选表单
    submitScreenForm() {
      this.currentPage = 1
      this.getList()
    },

    // 重置筛选表单
    resetScreenForm() {
      this.$refs.screenForm.resetFields()
      this.currentPage = 1
      this.getList()
    },

    // 更改每页数量
    handleSizeChange(val) {
      this.pageSize = val
      this.currentPage = 1
      this.getList()
    },

    // 更改当前页
    handleCurrentChange(val) {
      this.currentPage = val
      this.getList()
    },

    // 判断是否可以审批
    async examineJudge(item) {
      // 获取页面模版
      const result = await new Promise((resolve, reject) => {
        examineJudge({ id: item.id })
          .then(res => {
            resolve(res.code == 200)
          })
          .catch(res => {
            resolve(0)
          })
      })
      return result
    },

    // 进入表单
    toReturnForm(item) {
      this.queryItem = item
      this.isShowReturnForm = true
    },

    // 进入详情
    toDetail(item) {
      this.queryItem = item
      this.isShowDetail = true
    },

    // 进入审批
    async toExamine(item) {
      const canExamine = await this.examineJudge(item)
      if (!canExamine) {
        return false
      }
      this.queryItem = item
      this.isShowExamine = true
    },
    // 获取存货类别列表
    getCategoryList() {
      getCategoryList({
        pageNum: 1,
        pageSize: -1
      }).then(res => {
        this.categoryList = res.data.records
        console.log(this.categoryList)
      })
    },
    backList() {
      this.queryItem = {}
      this.isShowDetail = false
      this.isShowExamine = false
      this.isShowReturnForm = false
    },

    handleSelectionChange(val) {
      this.multipleSelection = val
    },

    // 打开 批量审批
    batchExamine() {
      this.isShowExamineDialog = true
    },

    // 提交 批量审批
    submitExamineForm() {
      const ids = this.multipleSelection.map(item => {
        return item.id
      })
      examineBatch({
        ids: ids.join(','),
        examineStatus: this.examineForm.status,
        approvalRemark: this.examineForm.remark
      }).then(res => {
        this.isShowExamineDialog = false
        this.getList()
        this.$successMsg('修改成功')
      })
    },

    // 弃审
    handleAbandon(id) {
      abandonData({ id }).then(res => {
        this.$successMsg()
        this.getList()
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
